package com.citygis.service;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import okhttp3.*;
import org.apache.http.Consts;
import org.apache.http.NameValuePair;
import org.apache.http.client.config.RequestConfig;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.CloseableHttpResponse;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.ContentType;
import org.apache.http.entity.StringEntity;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClients;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.util.EntityUtils;
import org.junit.Test;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.io.IOException;
import java.math.BigDecimal;
import java.sql.*;
import java.sql.Connection;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @Package com.citygis.service
 * @Author zyl
 * @Date 2024/3/8 0008 10:24
 * @description: ceshi
 */
@Service
public class BigDataService {

    public static void main(String[] args) throws SQLException, ClassNotFoundException {
        Class.forName("org.apache.hive.jdbc.HiveDriver");
        String jdbcUrl = "jdbc:hive2://10.1.161.88:10010/default";
        Connection conn = DriverManager.getConnection(jdbcUrl);
        PreparedStatement ps = conn.prepareStatement("START streamjob test_filter_insert_json_100w;");
//        ResultSet rs = ps.executeQuery();
//        int num = rs.getMetaData().getColumnCount();
//        while (rs.next()) {
//            for (int i = 1; i <= num; i++) {
//                System.out.println("column:" + i + rs.getObject(i));
//            }
//        }
//        rs.close();
        boolean execute = ps.execute();

        ps.close();
        conn.close();
    }

    @Test
    public void runTest() throws IOException, ClassNotFoundException, SQLException {
        Class.forName("org.apache.hive.jdbc.HiveDriver");
        String jdbcUrl = "jdbc:hive2://192.168.20.6:10000/tpcds_holodesk_2";
        Connection conn = DriverManager.getConnection(jdbcUrl);
        String sql = "select i_item_id,\n" +
                "        avg(ss_quantity) agg1,\n" +
                "        avg(ss_list_price) agg2,\n" +
                "        avg(ss_coupon_amt) agg3,\n" +
                "        avg(ss_sales_price) agg4\n" +
                " from store_sales\n" +
                "      JOIN date_dim ON store_sales.ss_sold_date_sk = date_dim.d_date_sk\n" +
                "      JOIN customer_demographics ON store_sales.ss_cdemo_sk = customer_demographics.cd_demo_sk\n" +
                "      JOIN promotion ON store_sales.ss_promo_sk = promotion.p_promo_sk\n" +
                "      JOIN item ON store_sales.ss_item_sk = item.i_item_sk\n" +
                " where\n" +
                "       cd_gender = 'F' and\n" +
                "       cd_marital_status = 'W' and\n" +
                "       cd_education_status = 'Primary' and\n" +
                "       (p_channel_email = 'N' or p_channel_event = 'N') and\n" +
                "       d_year = 1998\n" +
                " group by i_item_id\n" +
                " order by i_item_id\n" +
                " limit 100;";
        PreparedStatement ps = conn.prepareStatement(sql);
        ResultSet rs = ps.executeQuery();
        int num = rs.getMetaData().getColumnCount();
        while (rs.next()) {
            for (int i = 1; i <= num; i++) {
                System.out.println("column:" + i + rs.getObject(i));
            }
        }
        rs.close();
        ps.close();
        conn.close();
    }

    @Test
    public void excuteSql() throws IOException, ClassNotFoundException, SQLException {
//        String sql = "CREATE TABLE test_sqlserver_500(col1 varchar(50),col2 INT,col3 varchar(50),col4 decimal(20,6),col5  date,col6 varchar(50),col7 varchar(50),col8 varchar(50),col9 varchar(50),col10 varchar(50),col11 varchar(50),col12 varchar(50));";
        String sql = "delete from test_sqlserver_100;";
        Map<String, String> params = new HashMap<>();
        params.put("sql", sql);
        String resultHttp = doPost("http://10.1.161.182:4000/db/query",params);
        System.out.println(resultHttp);
    }


    @Test
    public void runDMTest() throws IOException, ClassNotFoundException, SQLException {

        Connection con;
        String driver = "dm.jdbc.driver.DmDriver";
        String url = "jdbc:dm://127.0.0.1:5236/test?zeroDateTimeBehavior=convertToNull&useUnicode=true&characterEncoding=utf-8";
        String user = "SYSDBA";
        String password = "SYSDBA";
        try {
            Class.forName(driver);
            con = DriverManager.getConnection(url, user, password);
            if (!con.isClosed())
                System.out.println("Succeeded connecting to the Database!");

            Statement statement = con.createStatement();
            //要执行的SQL语句
            String sql = "select * from \"test\".\"test\"";
            //3.ResultSet类，用来存放获取的结果集！！
            ResultSet rs = statement.executeQuery(sql);
            System.out.println("-----------------");
            System.out.println("执行结果如下所示:");
            System.out.println("-----------------");
            System.out.println("编号" + "\t" + "姓名");
            System.out.println("-----------------");

            String id = null;
            String name = null;
            while (rs.next()) {
                id = rs.getString("id");
                name = rs.getString("name");

                System.out.println(id + "\t" + name);
            }
            rs.close();
            con.close();
        } catch (ClassNotFoundException e) {
            System.out.println("Sorry,can`t find the Driver!");
            e.printStackTrace();
        } catch (SQLException e) {
            //数据库连接失败异常处理
            e.printStackTrace();
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            System.out.println("数据库数据成功获取！！");
        }
    }

    @Test
    public void testFile() {

    }

    public static String doPost(String url, Map<String, String> parameters) {
        String resultString = "";
        try {
            OkHttpClient client = new OkHttpClient();

            FormBody.Builder formBodyBuilder = new FormBody.Builder();

            // 添加所有参数到表单
            for (Map.Entry<String, String> param : parameters.entrySet()) {
                formBodyBuilder.add(param.getKey(), param.getValue());
            }
            RequestBody body = formBodyBuilder.build();

            Request request = new Request.Builder()
                    .url(url)
                    .post(body)
                    .addHeader("Content-Type", "application/x-www-form-urlencoded")
                    .build();
            Response response = client.newCall(request).execute();

            if (!response.isSuccessful()) throw new IOException("Unexpected code " + response);
            // 同样获取服务器返回的数据
            resultString = response.body().string();

        } catch (Exception e) {
            e.printStackTrace();
        } finally {
//            try {
////                client
//            } catch (IOException e) {
//                // TODO Auto-generated catch block
//                e.printStackTrace();
//            }
        }

        return resultString;
    }

    @Test
    public void testSqlserver() throws SQLException, ClassNotFoundException {
        System.out.println("开始时间" + new SimpleDateFormat("yyyy-MM-dd HH:mm:ss SSS").format(new java.util.Date()));

        Class.forName("com.microsoft.sqlserver.jdbc.SQLServerDriver");
        String jdbcUrl = "jdbc:sqlserver://localhost:1433;DatabaseName=master";
        Connection conn = DriverManager.getConnection(jdbcUrl, "sa", "123456");

        PreparedStatement ps_sql = conn.prepareStatement("select * from [dbo].[TABLE_100w] order by COLUMN_2 OFFSET ? ROWS FETCH NEXT ? ROWS ONLY;");
        ps_sql.setInt(1, 0);
        ps_sql.setInt(2, 10);
        ResultSet rs = ps_sql.executeQuery();

        String sql = "insert into test_sqlserver_100 values ";
        while (rs.next()){
            sql += "(";
            sql += "'" + rs.getString(1) + "',";
            sql += rs.getInt(2) + ",";
            sql += "'" + rs.getString(3) + "',";
            sql += rs.getBigDecimal(4) + ",";
            sql += "cast('"+rs.getDate(5)+"' as date),";
            sql += "'" + rs.getString(6) + "',";
            sql += "'" + rs.getString(7) + "',";
            sql += "'" + rs.getString(8) + "',";
            sql += "'" + rs.getString(9) + "',";
            sql += "'" + rs.getString(10) + "',";
            sql += "'" + rs.getString(11) + "',";
            sql += "'" + rs.getString(12) + "'";
            sql += "),";
        }
        sql = sql.substring(0,sql.length()-1) + ";";
        System.out.println(sql);

        rs.close();
        ps_sql.close();

        Map<String, String> params = new HashMap<>();
        params.put("sql", sql);
        String resultHttp = doPost("http://10.1.161.182:4000/db/query",params);
        System.out.println(resultHttp);

        System.out.println("结束时间" + new SimpleDateFormat("yyyy-MM-dd HH:mm:ss SSS").format(new java.util.Date()));

    }

    @Test
    public void testSqlserver100w() throws SQLException, ClassNotFoundException {
        System.out.println("开始时间" + new SimpleDateFormat("yyyy-MM-dd HH:mm:ss SSS").format(new java.util.Date()));

        Class.forName("com.microsoft.sqlserver.jdbc.SQLServerDriver");
        String jdbcUrl2 = "jdbc:sqlserver://localhost:1433;DatabaseName=master";
        Connection conn2 = DriverManager.getConnection(jdbcUrl2, "sa", "123456");

        PreparedStatement ps2 = conn2.prepareStatement("SELECT count(1) FROM [dbo].[TABLE_100w]");
        ResultSet rs = ps2.executeQuery();

        int total = 0;
        while (rs.next()) {
            total = (int) rs.getLong(1);
        }
        total = 2000;
        System.out.println("总数据量：" + total);
        ps2.close();

        Map<String, Object> map = new HashMap<>();
        int pageIndex = 1;
        int pageSize = 1000;
        int begin = pageSize * (pageIndex - 1);
        map.put("begin", begin);
        map.put("pageSize", pageSize);

        Integer totalInsert = 0;
        while (begin < total) {
            System.out.println(begin);
            map.put("begin", begin);
            PreparedStatement ps_sql = conn2.prepareStatement("select * from [dbo].[TABLE_100w] order by COLUMN_2 OFFSET ? ROWS FETCH NEXT ? ROWS ONLY;");
            ps_sql.setInt(1, begin);
            ps_sql.setInt(2, pageSize);
            ResultSet rs2 = ps_sql.executeQuery();

            Integer insertCount = 0;
            String sql = "insert into test_sqlserver_100 values ";
            while (rs2.next()){
                sql += insertCount.equals(0) ? "(" : ",(";
                sql += "'" + rs2.getString(1) + "',";
                sql += rs2.getInt(2) + ",";
                sql += "'" + rs2.getString(3) + "',";
                sql += rs2.getBigDecimal(4) + ",";
                sql += "cast('"+rs2.getDate(5)+"' as date),";
                sql += "'" + rs2.getString(6) + "',";
                sql += "'" + rs2.getString(7) + "',";
                sql += "'" + rs2.getString(8) + "',";
                sql += "'" + rs2.getString(9) + "',";
                sql += "'" + rs2.getString(10) + "',";
                sql += "'" + rs2.getString(11) + "',";
                sql += "'" + rs2.getString(12) + "'";
                sql += ")";


                totalInsert++;
                insertCount++;

                if(insertCount == 1000){
                    System.out.println(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss SSS").format(new java.util.Date()) + "  导入总行数" + totalInsert);

                    Map<String, String> params = new HashMap<>();
                    params.put("sql", sql);
                    String resultHttp = doPost("http://10.1.161.182:4000/db/query",params);
//                    System.out.println(resultHttp);
                    insertCount = 0;
                    sql = "insert into test_sqlserver_100 values ";
                }

            }
//            sql = sql.substring(0,sql.length()-1) + ";";


            pageIndex++;
            begin = pageSize * (pageIndex - 1);
        }
        conn2.close();
        System.out.println("结束时间" + new SimpleDateFormat("yyyy-MM-dd HH:mm:ss SSS").format(new java.util.Date()));

    }

//    public void testSqlserver500w() throws SQLException, ClassNotFoundException {
//        System.out.println("开始时间" + new SimpleDateFormat("yyyy-MM-dd HH:mm:ss SSS").format(new java.util.Date()));
//        Class.forName("org.apache.hive.jdbc.HiveDriver");
//        String jdbcUrl = "jdbc:hive2://10.1.161.88:10000/default";
//        Connection conn = DriverManager.getConnection(jdbcUrl);
//
//        Integer total = sqlServiceMapper.getCount_500();
//        System.out.println(total);
//
//        Map<String, Object> map = new HashMap<>();
//        int pageIndex = 1;
//        int pageSize = 150000;
//        int begin = pageSize * (pageIndex - 1);
//        map.put("begin", begin);
//        map.put("pageSize", pageSize);
//
//        while (begin <= total) {
//            System.out.println(begin);
//            map.put("begin", begin);
//            List<Map<String, Object>> all = sqlServiceMapper.getAll_500(map);
//
//            PreparedStatement ps = conn.prepareStatement("insert into test_sqlserver_500 values (?,?,?,?,?,?,?,?,?,?,?,?)");
//            for (Map<String, Object> m : all) {
//                ps.setString(1, String.valueOf(m.get("COLUMN_1")));
//                ps.setInt(2, (Integer) m.get("COLUMN_2"));
//                ps.setString(3, String.valueOf(m.get("COLUMN_3")));
//                ps.setBigDecimal(4, (BigDecimal) m.get("COLUMN_4"));
//                ps.setDate(5, (Date) m.get("COLUMN_5"));
//                ps.setString(6, String.valueOf(m.get("COLUMN_6")));
//                ps.setString(7, String.valueOf(m.get("COLUMN_7")));
//                ps.setString(8, String.valueOf(m.get("COLUMN_8")));
//                ps.setString(9, String.valueOf(m.get("COLUMN_9")));
//                ps.setString(10, String.valueOf(m.get("COLUMN_10")));
//                ps.setString(11, String.valueOf(m.get("COLUMN_11")));
//                ps.setString(12, String.valueOf(m.get("COLUMN_12")));
//                ps.addBatch();
//            }
//
//
//            System.out.println(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss SSS").format(new java.util.Date()) + "  addBatch" + pageIndex);
//
//            int[] execute = ps.executeBatch();
//            ps.close();
//
//            pageIndex++;
//            begin = pageSize * (pageIndex - 1);
//        }
//        conn.close();
//        System.out.println("结束时间" + new SimpleDateFormat("yyyy-MM-dd HH:mm:ss SSS").format(new java.util.Date()));
//
//    }


    //  -=================================  拉取數據
    @Test
    public void testMysql() throws SQLException, ClassNotFoundException {
        Class.forName("com.mysql.jdbc.Driver");
        String jdbcUrl = "jdbc:mysql://10.1.161.156:3306/for_export?characterEncoding=UTF-8&autoReconnect=true&useSSL=false&allowPublicKeyRetrieval=false";
        Connection conn = DriverManager.getConnection(jdbcUrl,"bdp","h@izhi2dp#bdp-core");

        PreparedStatement ps = conn.prepareStatement("SELECT count(1) FROM sqlserver_500");
        ResultSet rs = ps.executeQuery();

        int total = 0;
        while (rs.next()) {
            total = (int) rs.getLong(1);
        }
        System.out.println("总数据量：" + total);
    }


    @Test
    public void testQuery100w() throws SQLException, ClassNotFoundException {
        System.out.println("开始时间" + new SimpleDateFormat("yyyy-MM-dd HH:mm:ss SSS").format(new java.util.Date()));
        Class.forName("com.mysql.jdbc.Driver");
        String jdbcUrl = "jdbc:mysql://10.1.161.156:3306/for_export?characterEncoding=UTF-8&autoReconnect=true&useSSL=false&allowPublicKeyRetrieval=false";
        Connection conn = DriverManager.getConnection(jdbcUrl,"bdp","h@izhi2dp#bdp-core");

        PreparedStatement ps = conn.prepareStatement("SELECT count(1) FROM sqlserver_100");
        ResultSet rs = ps.executeQuery();

        int total = 0;
        while (rs.next()) {
            total = (int) rs.getLong(1);
        }
        System.out.println("总数据量：" + total);
        ps.close();

        int rowCount = 0;
//        Map<String, Object> map = new HashMap<>();
        int pageIndex = 1;
        int pageSize = 1000000;
        int begin = pageSize * (pageIndex - 1);
//        map.put("begin",begin);
//        map.put("pageSize",pageSize);

        System.out.println("开始查询" + new SimpleDateFormat("yyyy-MM-dd HH:mm:ss SSS").format(new java.util.Date()));
        while (begin < total) {
//        while (begin <= total) {
//            System.out.println(begin);
            PreparedStatement ps2 = conn.prepareStatement("SELECT * FROM sqlserver_100 LIMIT ?,?");
            ps2.setInt(1, begin);
            ps2.setInt(2, pageSize);

            ResultSet rs2 = ps2.executeQuery();
            ResultSetMetaData rsmd = rs2.getMetaData();
            int size = rsmd.getColumnCount();
            while (rs2.next()) {
//                StringBuffer value = new StringBuffer();
//                for (int i = 0; i < size; i++) {
//                    value.append(rs2.getString(i + 1)).append("\t");
//                }
//                // 获取输出结果并关闭连接
//                System.out.println(value.toString());
                rowCount++;
            }

            System.out.println(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss SSS").format(new java.util.Date()) + "  查询总行数" + rowCount);

            rs2.close();
            ps2.close();

            pageIndex++;
            begin = pageSize * (pageIndex - 1);
        }
        conn.close();
        System.out.println("结束时间" + new SimpleDateFormat("yyyy-MM-dd HH:mm:ss SSS").format(new java.util.Date()));

    }

    @Test
    public void testQuery500w() throws SQLException, ClassNotFoundException {
        System.out.println("开始时间" + new SimpleDateFormat("yyyy-MM-dd HH:mm:ss SSS").format(new java.util.Date()));
        Class.forName("com.mysql.jdbc.Driver");
        String jdbcUrl = "jdbc:mysql://10.1.161.156:3306/for_export?characterEncoding=UTF-8&autoReconnect=true&useSSL=false&allowPublicKeyRetrieval=false";
        Connection conn = DriverManager.getConnection(jdbcUrl,"bdp","h@izhi2dp#bdp-core");

        PreparedStatement ps = conn.prepareStatement("SELECT count(1) FROM sqlserver_500");
        ResultSet rs = ps.executeQuery();

        int total = 0;
        while (rs.next()) {
            total = (int) rs.getLong(1);
        }
        System.out.println("总数据量：" + total);
        ps.close();

        int rowCount = 0;
//        Map<String, Object> map = new HashMap<>();
        int pageIndex = 1;
        int pageSize = 1000000;
        int begin = pageSize * (pageIndex - 1);
//        map.put("begin",begin);
//        map.put("pageSize",pageSize);

        System.out.println("开始查询" + new SimpleDateFormat("yyyy-MM-dd HH:mm:ss SSS").format(new java.util.Date()));
        while (begin < total) {
//        while (begin <= total) {
//            System.out.println(begin);
            PreparedStatement ps2 = conn.prepareStatement("SELECT * FROM sqlserver_500 LIMIT ?,?");
            ps2.setInt(1, begin);
            ps2.setInt(2, pageSize);

            ResultSet rs2 = ps2.executeQuery();
            ResultSetMetaData rsmd = rs2.getMetaData();
            int size = rsmd.getColumnCount();
            while (rs2.next()) {
//                StringBuffer value = new StringBuffer();
//                for (int i = 0; i < size; i++) {
//                    value.append(rs2.getString(i + 1)).append("\t");
//                }
//                // 获取输出结果并关闭连接
//                System.out.println(value.toString());
                rowCount++;
            }

            System.out.println(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss SSS").format(new java.util.Date()) + "  查询总行数" + rowCount);

            rs2.close();
            ps2.close();

            pageIndex++;
            begin = pageSize * (pageIndex - 1);
        }
        conn.close();
        System.out.println("结束时间" + new SimpleDateFormat("yyyy-MM-dd HH:mm:ss SSS").format(new java.util.Date()));

    }

    @Test
    public void testQueryAndInsert100w() throws SQLException, ClassNotFoundException {
        System.out.println("开始时间" + new SimpleDateFormat("yyyy-MM-dd HH:mm:ss SSS").format(new java.util.Date()));
        Class.forName("com.mysql.jdbc.Driver");
        String jdbcUrl = "jdbc:mysql://10.1.161.156:3306/for_export?characterEncoding=UTF-8&autoReconnect=true&useSSL=false&allowPublicKeyRetrieval=false";
        Connection conn = DriverManager.getConnection(jdbcUrl,"bdp","h@izhi2dp#bdp-core");

        Class.forName("com.microsoft.sqlserver.jdbc.SQLServerDriver");
        String jdbcUrl2 = "jdbc:sqlserver://localhost:1433;DatabaseName=master";
        Connection conn2 = DriverManager.getConnection(jdbcUrl2, "sa", "123456");


        PreparedStatement ps = conn.prepareStatement("SELECT count(1) FROM sqlserver_100");
        ResultSet rs = ps.executeQuery();

        int total = 0;
        while (rs.next()) {
            total = (int) rs.getLong(1);
        }
        System.out.println("总数据量：" + total);
        ps.close();

        int rowCount = 0;
//        Map<String, Object> map = new HashMap<>();
        int pageIndex = 1;
        int pageSize = 1000000;
        int begin = pageSize * (pageIndex - 1);
//        map.put("begin",begin);
//        map.put("pageSize",pageSize);

        int totalInsert = 0;

        System.out.println("开始查询" + new SimpleDateFormat("yyyy-MM-dd HH:mm:ss SSS").format(new java.util.Date()));
        while (begin < total) {
//        while (begin <= total) {
//            System.out.println(begin);
            PreparedStatement ps2 = conn.prepareStatement("SELECT * FROM sqlserver_100 LIMIT ?,?");
            ps2.setInt(1, begin);
            ps2.setInt(2, pageSize);

            System.out.println(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss SSS").format(new java.util.Date()) + "  第" + pageIndex + "次查询");

            ResultSet rs2 = ps2.executeQuery();
            ResultSetMetaData rsmd = rs2.getMetaData();
            int size = rsmd.getColumnCount();
            PreparedStatement ps_sqlserver = conn2.prepareStatement("insert into [dbo].[TABLE_100w_2] values (?,?,?,?,?,?,?,?,?,?,?,?)");
            int insertcount = 0;
            while (rs2.next()) {

                ps_sqlserver.setString(1, rs2.getString(1));
                ps_sqlserver.setInt(2, rs2.getInt(2));
                ps_sqlserver.setString(3, rs2.getString(3));
                ps_sqlserver.setBigDecimal(4, rs2.getBigDecimal(4));
                ps_sqlserver.setDate(5, rs2.getDate(5));
                ps_sqlserver.setString(6, rs2.getString(6));
                ps_sqlserver.setString(7, rs2.getString(7));
                ps_sqlserver.setString(8, rs2.getString(8));
                ps_sqlserver.setString(9, rs2.getString(9));
                ps_sqlserver.setString(10, rs2.getString(10));
                ps_sqlserver.setString(11, rs2.getString(11));
                ps_sqlserver.setString(12, rs2.getString(12));
                ps_sqlserver.addBatch();

                insertcount++;
                totalInsert++;

                if (insertcount == 100000) {
                    insertcount = 0;
                    ps_sqlserver.executeBatch();
                    ps_sqlserver.clearBatch();
                    System.out.println(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss SSS").format(new java.util.Date()) + "  插入总行数" + totalInsert);
                }


//                StringBuffer value = new StringBuffer();
//                for (int i = 0; i < size; i++) {
//                    value.append(rs2.getString(i + 1)).append("\t");
//                }
//                // 获取输出结果并关闭连接
//                System.out.println(value.toString());
                rowCount++;
            }
            ps_sqlserver.close();

//            System.out.println(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss SSS").format(new java.util.Date()) + "  查询总行数" + rowCount);

            rs2.close();
            ps2.close();

            pageIndex++;
            begin = pageSize * (pageIndex - 1);
        }
        conn.close();
        System.out.println("结束时间" + new SimpleDateFormat("yyyy-MM-dd HH:mm:ss SSS").format(new java.util.Date()));

    }

    @Test
    public void testQueryAndInsert500w() throws SQLException, ClassNotFoundException {
        System.out.println("开始时间" + new SimpleDateFormat("yyyy-MM-dd HH:mm:ss SSS").format(new java.util.Date()));
        Class.forName("com.mysql.jdbc.Driver");
        String jdbcUrl = "jdbc:mysql://10.1.161.156:3306/for_export?characterEncoding=UTF-8&autoReconnect=true&useSSL=false&allowPublicKeyRetrieval=false";
        Connection conn = DriverManager.getConnection(jdbcUrl,"bdp","h@izhi2dp#bdp-core");

        Class.forName("com.microsoft.sqlserver.jdbc.SQLServerDriver");
        String jdbcUrl2 = "jdbc:sqlserver://localhost:1433;DatabaseName=master";
        Connection conn2 = DriverManager.getConnection(jdbcUrl2, "sa", "123456");


        PreparedStatement ps = conn.prepareStatement("SELECT count(1) FROM sqlserver_500");
        ResultSet rs = ps.executeQuery();

        int total = 0;
        while (rs.next()) {
            total = (int) rs.getLong(1);
        }
        System.out.println("总数据量：" + total);
        ps.close();

        int rowCount = 0;
//        Map<String, Object> map = new HashMap<>();
        int pageIndex = 1;
        int pageSize = 1000000;
        int begin = pageSize * (pageIndex - 1);
//        map.put("begin",begin);
//        map.put("pageSize",pageSize);

        int totalInsert = 0;

        System.out.println("开始查询" + new SimpleDateFormat("yyyy-MM-dd HH:mm:ss SSS").format(new java.util.Date()));
        while (begin < total) {
//        while (begin <= total) {
//            System.out.println(begin);
            PreparedStatement ps2 = conn.prepareStatement("SELECT * FROM sqlserver_500 LIMIT ?,?");
            ps2.setInt(1, begin);
            ps2.setInt(2, pageSize);

            System.out.println(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss SSS").format(new java.util.Date()) + "  第" + pageIndex + "次查询");

            ResultSet rs2 = ps2.executeQuery();
            ResultSetMetaData rsmd = rs2.getMetaData();
            int size = rsmd.getColumnCount();
            PreparedStatement ps_sqlserver = conn2.prepareStatement("insert into [dbo].[TABLE_500w_2] values (?,?,?,?,?,?,?,?,?,?,?,?)");
            int insertcount = 0;
            while (rs2.next()) {

                ps_sqlserver.setString(1, rs2.getString(1));
                ps_sqlserver.setInt(2, rs2.getInt(2));
                ps_sqlserver.setString(3, rs2.getString(3));
                ps_sqlserver.setBigDecimal(4, rs2.getBigDecimal(4));
                ps_sqlserver.setDate(5, rs2.getDate(5));
                ps_sqlserver.setString(6, rs2.getString(6));
                ps_sqlserver.setString(7, rs2.getString(7));
                ps_sqlserver.setString(8, rs2.getString(8));
                ps_sqlserver.setString(9, rs2.getString(9));
                ps_sqlserver.setString(10, rs2.getString(10));
                ps_sqlserver.setString(11, rs2.getString(11));
                ps_sqlserver.setString(12, rs2.getString(12));
                ps_sqlserver.addBatch();

                insertcount++;
                totalInsert++;

                if (insertcount == 100000) {
                    insertcount = 0;
                    ps_sqlserver.executeBatch();
                    ps_sqlserver.clearBatch();
                    System.out.println(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss SSS").format(new java.util.Date()) + "  插入总行数" + totalInsert);
                }


//                StringBuffer value = new StringBuffer();
//                for (int i = 0; i < size; i++) {
//                    value.append(rs2.getString(i + 1)).append("\t");
//                }
//                // 获取输出结果并关闭连接
//                System.out.println(value.toString());
                rowCount++;
            }
            ps_sqlserver.close();

//            System.out.println(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss SSS").format(new java.util.Date()) + "  查询总行数" + rowCount);

            rs2.close();
            ps2.close();

            pageIndex++;
            begin = pageSize * (pageIndex - 1);
        }
        conn.close();
        System.out.println("结束时间" + new SimpleDateFormat("yyyy-MM-dd HH:mm:ss SSS").format(new java.util.Date()));

    }

//  -=================================  拉取數據


    @Test
    public void testdm100w() throws SQLException, ClassNotFoundException {
        System.out.println("开始时间" + new SimpleDateFormat("yyyy-MM-dd HH:mm:ss SSS").format(new java.util.Date()));
        Class.forName("org.apache.hive.jdbc.HiveDriver");
        String jdbcUrl = "jdbc:hive2://10.1.161.88:10000/default";
        Connection conn = DriverManager.getConnection(jdbcUrl);

        Class.forName("dm.jdbc.driver.DmDriver");
        String jdbcUrl2 = "jdbc:dm://127.0.0.1:5236/test?zeroDateTimeBehavior=convertToNull&useUnicode=true&characterEncoding=utf-8";
        Connection conn2 = DriverManager.getConnection(jdbcUrl2, "SYSDBA", "SYSDBA");

        PreparedStatement ps_dm = conn2.prepareStatement("SELECT count(1) FROM \"test\".\"TABLE_1_100w\"");
        ResultSet rs_dm = ps_dm.executeQuery();

        int total = 0;
        while (rs_dm.next()) {
            total = (int) rs_dm.getLong(1);
        }
        System.out.println("总数据量：" + total);
        ps_dm.close();
//        Integer total = sqlServiceMapper.getCount();
//        System.out.println(total);

        Map<String, Object> map = new HashMap<>();
        int pageIndex = 1;
        int pageSize = 150000;
        int begin = pageSize * (pageIndex - 1);
        map.put("begin", begin);
        map.put("pageSize", pageSize);

        while (begin <= total) {
            System.out.println(begin);
            map.put("begin", begin);

            PreparedStatement ps_list = conn2.prepareStatement("SELECT * FROM \"test\".\"TABLE_1_100w\" LIMIT ?,?");
            ps_list.setInt(1, begin);
            ps_list.setInt(2, pageSize);

            System.out.println(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss SSS").format(new java.util.Date()) + "  第" + pageIndex + "次查询");

            ResultSet rs_list = ps_list.executeQuery();
//            List<Map<String, Object>> all = sqlServiceMapper.getAll(map);

            PreparedStatement ps = conn.prepareStatement("insert into test_dm_100 values (?,?,?,?,?,?,?,?,?,?,?,?)");

            while (rs_list.next()) {
                ps.setString(1, rs_list.getString(1));
                ps.setInt(2, rs_list.getInt(2));
                ps.setString(3, rs_list.getString(3));
                ps.setBigDecimal(4, rs_list.getBigDecimal(4));
                ps.setDate(5, rs_list.getDate(5));
                ps.setString(6, rs_list.getString(6));
                ps.setString(7, rs_list.getString(7));
                ps.setString(8, rs_list.getString(8));
                ps.setString(9, rs_list.getString(9));
                ps.setString(10, rs_list.getString(10));
                ps.setString(11, rs_list.getString(11));
                ps.setString(12, rs_list.getString(12));
                ps.addBatch();
            }


            System.out.println(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss SSS").format(new java.util.Date()) + "  addBatch" + pageIndex);

            int[] execute = ps.executeBatch();
            ps.close();

            pageIndex++;
            begin = pageSize * (pageIndex - 1);
        }
        conn.close();
        System.out.println("结束时间" + new SimpleDateFormat("yyyy-MM-dd HH:mm:ss SSS").format(new java.util.Date()));

    }

    @Test
    public void testdm500w() throws SQLException, ClassNotFoundException {
        System.out.println("开始时间" + new SimpleDateFormat("yyyy-MM-dd HH:mm:ss SSS").format(new java.util.Date()));
        Class.forName("org.apache.hive.jdbc.HiveDriver");
        String jdbcUrl = "jdbc:hive2://10.1.161.88:10000/default";
        Connection conn = DriverManager.getConnection(jdbcUrl);

        Class.forName("dm.jdbc.driver.DmDriver");
        String jdbcUrl2 = "jdbc:dm://127.0.0.1:5236/test?zeroDateTimeBehavior=convertToNull&useUnicode=true&characterEncoding=utf-8";
        Connection conn2 = DriverManager.getConnection(jdbcUrl2, "SYSDBA", "SYSDBA");

        PreparedStatement ps_dm = conn2.prepareStatement("SELECT count(1) FROM \"test\".\"TABLE_2_500w\"");
        ResultSet rs_dm = ps_dm.executeQuery();

        int total = 0;
        while (rs_dm.next()) {
            total = (int) rs_dm.getLong(1);
        }
        System.out.println("总数据量：" + total);
        ps_dm.close();
//        Integer total = sqlServiceMapper.getCount();
//        System.out.println(total);

        Map<String, Object> map = new HashMap<>();
        int pageIndex = 1;
        int pageSize = 150000;
        int begin = pageSize * (pageIndex - 1);
        map.put("begin", begin);
        map.put("pageSize", pageSize);

        while (begin <= total) {
            System.out.println(begin);
            map.put("begin", begin);

            PreparedStatement ps_list = conn2.prepareStatement("SELECT * FROM \"test\".\"TABLE_2_500w\" LIMIT ?,?");
            ps_list.setInt(1, begin);
            ps_list.setInt(2, pageSize);

            System.out.println(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss SSS").format(new java.util.Date()) + "  第" + pageIndex + "次查询");

            ResultSet rs_list = ps_list.executeQuery();
//            List<Map<String, Object>> all = sqlServiceMapper.getAll(map);

            PreparedStatement ps = conn.prepareStatement("insert into test_dm_500 values (?,?,?,?,?,?,?,?,?,?,?,?)");

            while (rs_list.next()) {
                ps.setString(1, rs_list.getString(1));
                ps.setInt(2, rs_list.getInt(2));
                ps.setString(3, rs_list.getString(3));
                ps.setBigDecimal(4, rs_list.getBigDecimal(4));
                ps.setDate(5, rs_list.getDate(5));
                ps.setString(6, rs_list.getString(6));
                ps.setString(7, rs_list.getString(7));
                ps.setString(8, rs_list.getString(8));
                ps.setString(9, rs_list.getString(9));
                ps.setString(10, rs_list.getString(10));
                ps.setString(11, rs_list.getString(11));
                ps.setString(12, rs_list.getString(12));
                ps.addBatch();
            }


            System.out.println(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss SSS").format(new java.util.Date()) + "  addBatch" + pageIndex);

            int[] execute = ps.executeBatch();
            ps.close();

            pageIndex++;
            begin = pageSize * (pageIndex - 1);
        }
        conn.close();
        System.out.println("结束时间" + new SimpleDateFormat("yyyy-MM-dd HH:mm:ss SSS").format(new java.util.Date()));

    }


    @Test
    public void testQueryDm100w() throws SQLException, ClassNotFoundException {
        System.out.println("开始时间" + new SimpleDateFormat("yyyy-MM-dd HH:mm:ss SSS").format(new java.util.Date()));
        Class.forName("org.apache.hive.jdbc.HiveDriver");
        String jdbcUrl = "jdbc:hive2://10.1.161.88:10000/default";
        Connection conn = DriverManager.getConnection(jdbcUrl);

        PreparedStatement ps = conn.prepareStatement("SELECT count(1) FROM test_dm_100");
        ResultSet rs = ps.executeQuery();

        int total = 0;
        while (rs.next()) {
            total = (int) rs.getLong(1);
        }
        System.out.println("总数据量：" + total);
        ps.close();

        int rowCount = 0;
//        Map<String, Object> map = new HashMap<>();
        int pageIndex = 1;
        int pageSize = 1000000;
        int begin = pageSize * (pageIndex - 1);
//        map.put("begin",begin);
//        map.put("pageSize",pageSize);

        System.out.println("开始查询" + new SimpleDateFormat("yyyy-MM-dd HH:mm:ss SSS").format(new java.util.Date()));
        while (begin < total) {
//        while (begin <= total) {
//            System.out.println(begin);
            PreparedStatement ps2 = conn.prepareStatement("SELECT * FROM test_dm_100 LIMIT ?,?");
            ps2.setInt(1, begin);
            ps2.setInt(2, pageSize);

            ResultSet rs2 = ps2.executeQuery();
            ResultSetMetaData rsmd = rs2.getMetaData();
            int size = rsmd.getColumnCount();
            while (rs2.next()) {
//                StringBuffer value = new StringBuffer();
//                for (int i = 0; i < size; i++) {
//                    value.append(rs2.getString(i + 1)).append("\t");
//                }
//                // 获取输出结果并关闭连接
//                System.out.println(value.toString());
                rowCount++;
            }

            System.out.println(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss SSS").format(new java.util.Date()) + "  查询总行数" + rowCount);

            rs2.close();
            ps2.close();

            pageIndex++;
            begin = pageSize * (pageIndex - 1);
        }
        conn.close();
        System.out.println("结束时间" + new SimpleDateFormat("yyyy-MM-dd HH:mm:ss SSS").format(new java.util.Date()));

    }

    @Test
    public void testQueryDm500w() throws SQLException, ClassNotFoundException {
        System.out.println("开始时间" + new SimpleDateFormat("yyyy-MM-dd HH:mm:ss SSS").format(new java.util.Date()));
        Class.forName("org.apache.hive.jdbc.HiveDriver");
        String jdbcUrl = "jdbc:hive2://10.1.161.88:10000/default";
        Connection conn = DriverManager.getConnection(jdbcUrl);

        PreparedStatement ps = conn.prepareStatement("SELECT count(1) FROM test_dm_500");
        ResultSet rs = ps.executeQuery();

        int total = 0;
        while (rs.next()) {
            total = (int) rs.getLong(1);
        }
        System.out.println("总数据量：" + total);
        ps.close();

        int rowCount = 0;
//        Map<String, Object> map = new HashMap<>();
        int pageIndex = 1;
        int pageSize = 1000000;
        int begin = pageSize * (pageIndex - 1);
//        map.put("begin",begin);
//        map.put("pageSize",pageSize);

        System.out.println("开始查询" + new SimpleDateFormat("yyyy-MM-dd HH:mm:ss SSS").format(new java.util.Date()));
        while (begin < total) {
//        while (begin <= total) {
//            System.out.println(begin);
            PreparedStatement ps2 = conn.prepareStatement("SELECT * FROM test_dm_500 LIMIT ?,?");
            ps2.setInt(1, begin);
            ps2.setInt(2, pageSize);

            ResultSet rs2 = ps2.executeQuery();
            ResultSetMetaData rsmd = rs2.getMetaData();
            int size = rsmd.getColumnCount();
            while (rs2.next()) {
//                StringBuffer value = new StringBuffer();
//                for (int i = 0; i < size; i++) {
//                    value.append(rs2.getString(i + 1)).append("\t");
//                }
//                // 获取输出结果并关闭连接
//                System.out.println(value.toString());
                rowCount++;
            }

            System.out.println(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss SSS").format(new java.util.Date()) + "  查询总行数" + rowCount);

            rs2.close();
            ps2.close();

            pageIndex++;
            begin = pageSize * (pageIndex - 1);
        }
        conn.close();
        System.out.println("结束时间" + new SimpleDateFormat("yyyy-MM-dd HH:mm:ss SSS").format(new java.util.Date()));

    }

    @Test
    public void testQueryAndDMInsert100w() throws SQLException, ClassNotFoundException {
        System.out.println("开始时间" + new SimpleDateFormat("yyyy-MM-dd HH:mm:ss SSS").format(new java.util.Date()));
        Class.forName("org.apache.hive.jdbc.HiveDriver");
        String jdbcUrl = "jdbc:hive2://10.1.161.88:10000/default";
        Connection conn = DriverManager.getConnection(jdbcUrl);

        Class.forName("dm.jdbc.driver.DmDriver");
        String jdbcUrl2 = "jdbc:dm://127.0.0.1:5236/test?zeroDateTimeBehavior=convertToNull&useUnicode=true&characterEncoding=utf-8";
        Connection conn2 = DriverManager.getConnection(jdbcUrl2, "SYSDBA", "SYSDBA");


        PreparedStatement ps = conn.prepareStatement("SELECT count(1) FROM test_dm_100");
        ResultSet rs = ps.executeQuery();

        int total = 0;
        while (rs.next()) {
            total = (int) rs.getLong(1);
        }
        System.out.println("总数据量：" + total);
        ps.close();

        int rowCount = 0;
//        Map<String, Object> map = new HashMap<>();
        int pageIndex = 1;
        int pageSize = 1000000;
        int begin = pageSize * (pageIndex - 1);
//        map.put("begin",begin);
//        map.put("pageSize",pageSize);

        int totalInsert = 0;

        System.out.println("开始查询" + new SimpleDateFormat("yyyy-MM-dd HH:mm:ss SSS").format(new java.util.Date()));
        while (begin < total) {
//        while (begin <= total) {
//            System.out.println(begin);
            PreparedStatement ps2 = conn.prepareStatement("SELECT * FROM test_dm_100 LIMIT ?,?");
            ps2.setInt(1, begin);
            ps2.setInt(2, pageSize);

            System.out.println(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss SSS").format(new java.util.Date()) + "  第" + pageIndex + "次查询");

            ResultSet rs2 = ps2.executeQuery();
            ResultSetMetaData rsmd = rs2.getMetaData();
            int size = rsmd.getColumnCount();
            PreparedStatement ps_sqlserver = conn2.prepareStatement("insert into \"test\".\"TABLE_1_100w_in\" values (?,?,?,?,?,?,?,?,?,?,?,?)");
            int insertcount = 0;
            while (rs2.next()) {

                ps_sqlserver.setString(1, rs2.getString(1));
                ps_sqlserver.setInt(2, rs2.getInt(2));
                ps_sqlserver.setString(3, rs2.getString(3));
                ps_sqlserver.setBigDecimal(4, rs2.getBigDecimal(4));
                ps_sqlserver.setDate(5, rs2.getDate(5));
                ps_sqlserver.setString(6, rs2.getString(6));
                ps_sqlserver.setString(7, rs2.getString(7));
                ps_sqlserver.setString(8, rs2.getString(8));
                ps_sqlserver.setString(9, rs2.getString(9));
                ps_sqlserver.setString(10, rs2.getString(10));
                ps_sqlserver.setString(11, rs2.getString(11));
                ps_sqlserver.setString(12, rs2.getString(12));
                ps_sqlserver.addBatch();

                insertcount++;
                totalInsert++;

                if (insertcount == 100000) {
                    insertcount = 0;
                    ps_sqlserver.executeBatch();
                    ps_sqlserver.clearBatch();
                    System.out.println(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss SSS").format(new java.util.Date()) + "  插入总行数" + totalInsert);
                }


//                StringBuffer value = new StringBuffer();
//                for (int i = 0; i < size; i++) {
//                    value.append(rs2.getString(i + 1)).append("\t");
//                }
//                // 获取输出结果并关闭连接
//                System.out.println(value.toString());
                rowCount++;
            }
            ps_sqlserver.close();

//            System.out.println(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss SSS").format(new java.util.Date()) + "  查询总行数" + rowCount);

            rs2.close();
            ps2.close();

            pageIndex++;
            begin = pageSize * (pageIndex - 1);
        }
        conn.close();
        System.out.println("结束时间" + new SimpleDateFormat("yyyy-MM-dd HH:mm:ss SSS").format(new java.util.Date()));

    }

    @Test
    public void testQueryAndDMInsert500w() throws SQLException, ClassNotFoundException {
        System.out.println("开始时间" + new SimpleDateFormat("yyyy-MM-dd HH:mm:ss SSS").format(new java.util.Date()));
        Class.forName("org.apache.hive.jdbc.HiveDriver");
        String jdbcUrl = "jdbc:hive2://10.1.161.88:10000/default";
        Connection conn = DriverManager.getConnection(jdbcUrl);

        Class.forName("dm.jdbc.driver.DmDriver");
        String jdbcUrl2 = "jdbc:dm://127.0.0.1:5236/test?zeroDateTimeBehavior=convertToNull&useUnicode=true&characterEncoding=utf-8";
        Connection conn2 = DriverManager.getConnection(jdbcUrl2, "SYSDBA", "SYSDBA");


        PreparedStatement ps = conn.prepareStatement("SELECT count(1) FROM test_dm_500");
        ResultSet rs = ps.executeQuery();

        int total = 0;
        while (rs.next()) {
            total = (int) rs.getLong(1);
        }
        System.out.println("总数据量：" + total);
        ps.close();

        int rowCount = 0;
//        Map<String, Object> map = new HashMap<>();
        int pageIndex = 1;
        int pageSize = 1000000;
        int begin = pageSize * (pageIndex - 1);
//        map.put("begin",begin);
//        map.put("pageSize",pageSize);

        int totalInsert = 0;

        System.out.println("开始查询" + new SimpleDateFormat("yyyy-MM-dd HH:mm:ss SSS").format(new java.util.Date()));
        while (begin < total) {
//        while (begin <= total) {
//            System.out.println(begin);
            PreparedStatement ps2 = conn.prepareStatement("SELECT * FROM test_dm_500 LIMIT ?,?");
            ps2.setInt(1, begin);
            ps2.setInt(2, pageSize);

            System.out.println(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss SSS").format(new java.util.Date()) + "  第" + pageIndex + "次查询");

            ResultSet rs2 = ps2.executeQuery();
            ResultSetMetaData rsmd = rs2.getMetaData();
            int size = rsmd.getColumnCount();
            PreparedStatement ps_sqlserver = conn2.prepareStatement("insert into \"test\".\"TABLE_2_500w_in\" values (?,?,?,?,?,?,?,?,?,?,?,?)");
            int insertcount = 0;
            while (rs2.next()) {

                ps_sqlserver.setString(1, rs2.getString(1));
                ps_sqlserver.setInt(2, rs2.getInt(2));
                ps_sqlserver.setString(3, rs2.getString(3));
                ps_sqlserver.setBigDecimal(4, rs2.getBigDecimal(4));
                ps_sqlserver.setDate(5, rs2.getDate(5));
                ps_sqlserver.setString(6, rs2.getString(6));
                ps_sqlserver.setString(7, rs2.getString(7));
                ps_sqlserver.setString(8, rs2.getString(8));
                ps_sqlserver.setString(9, rs2.getString(9));
                ps_sqlserver.setString(10, rs2.getString(10));
                ps_sqlserver.setString(11, rs2.getString(11));
                ps_sqlserver.setString(12, rs2.getString(12));
                ps_sqlserver.addBatch();

                insertcount++;
                totalInsert++;

                if (insertcount == 100000) {
                    insertcount = 0;
                    ps_sqlserver.executeBatch();
                    ps_sqlserver.clearBatch();
                    System.out.println(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss SSS").format(new java.util.Date()) + "  插入总行数" + totalInsert);
                }


//                StringBuffer value = new StringBuffer();
//                for (int i = 0; i < size; i++) {
//                    value.append(rs2.getString(i + 1)).append("\t");
//                }
//                // 获取输出结果并关闭连接
//                System.out.println(value.toString());
                rowCount++;
            }
            ps_sqlserver.close();

//            System.out.println(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss SSS").format(new java.util.Date()) + "  查询总行数" + rowCount);

            rs2.close();
            ps2.close();

            pageIndex++;
            begin = pageSize * (pageIndex - 1);
        }
        conn.close();
        System.out.println("结束时间" + new SimpleDateFormat("yyyy-MM-dd HH:mm:ss SSS").format(new java.util.Date()));

    }
}